#include <stdlib.h>
#include <avr/io.h>
#include <util/delay.h>

#define STEP_DELAY 45
#define SCAN_DELAY 200

void init() {
	PORTB = 0;
	PORTD = 0;
	PORTA = 0;
	DDRB = 0xff;
	DDRD = 0x7f;
	DDRA = 0x03;
}

int main() {
	char i;
	unsigned long d;

	init();
	while(1) {
		d = 1;
		for(i = 0; i < 17; i++) {
			PORTB = (d & 0xff);
			PORTD = (d >> 8) & 0x7f;
			PORTA = (d >> 15) & 0x03;
			_delay_ms(STEP_DELAY);
			d <<= 1;
		}
		_delay_ms(SCAN_DELAY);
		for(i = 0; i < 17; i++) {
			d >>= 1;
			PORTB = (d & 0xff);
			PORTD = (d >> 8) & 0x7f;
			PORTA = (d >> 15) & 0x03;
			_delay_ms(STEP_DELAY);
		}
		_delay_ms(SCAN_DELAY);
	}

	return 0; // unreached
}
